<html>
  <head>
	  <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <title>i5ting_ztree_toc:说明</title>
		<link href="toc/style/github-bf51422f4bb36427d391e4b75a1daa083c2d840e.css" media="all" rel="stylesheet" type="text/css"/>
		<link href="toc/style/github2-d731afd4f624c99a4b19ad69f3083cd6d02b81d5.css" media="all" rel="stylesheet" type="text/css"/>
		<link href="toc/css/zTreeStyle/zTreeStyle.css" media="all" rel="stylesheet" type="text/css"/>
	  <style>
		pre {
		    counter-reset: line-numbering;
		    border: solid 1px #d9d9d9;
		    border-radius: 0;
		    background: #fff;
		    padding: 0;
		    line-height: 23px;
		    margin-bottom: 30px;
		    white-space: pre;
		    overflow-x: auto;
		    word-break: inherit;
		    word-wrap: inherit;
		}

		pre a::before {
		  content: counter(line-numbering);
		  counter-increment: line-numbering;
		  padding-right: 1em; /* space after numbers */
		  width: 25px;
		  text-align: right;
		  opacity: 0.7;
		  display: inline-block;
		  color: #aaa;
		  background: #eee;
		  margin-right: 16px;
		  padding: 2px 10px;
		  font-size: 13px;
		  -webkit-touch-callout: none;
		  -webkit-user-select: none;
		  -khtml-user-select: none;
		  -moz-user-select: none;
		  -ms-user-select: none;
		  user-select: none;
		}

		pre a:first-of-type::before {
		  padding-top: 10px;
		}

		pre a:last-of-type::before {
		  padding-bottom: 10px;
		}

		pre a:only-of-type::before {
		  padding: 10px;
		}

		.highlight { background-color: #ffffcc } /* RIGHT */
		</style>
  </head>
  <body>
	  <div>
				<div style='width:25%;'>
						<ul id="tree" class="ztree" style='width:100%'>

						</ul>
				</div>
        <div id='readme' style='width:70%;margin-left:20%;'>
          	<article class='markdown-body'>
            	<h1 id="-vue-">学习vue项目担心什么？</h1>
<ol>
<li>写着写着跟不上节奏 bug多 (手把手的带着大家写代码 甚至html 和 css这一块都会带着你编写)</li>
<li>数据拿不到 </li>
</ol>
<h1 id="-vue3-vite-vue-">用vue3+vite 搭建vue通用后台管理</h1>
<blockquote>
<p>项目的演示
大家注意我的node版本 vue-cli版本
尽量少用粘贴复制，手写代码的方式实现
没有vue3基础的也没关系 我们会在讲解中穿插vue3的知识</p>
</blockquote>
<h1 id="vite-vue-">vite快速构建vue项目</h1>
<ul>
<li>vite官网

<a href="https://cn.vitejs.dev/guide/#scaffolding-your-first-vite-project">vite官网</a></li>
<li>element-plus官网
<a href="https://element-plus.gitee.io/zh-CN/component/button.html">element-plus官网</a></li>
</ul>
<h1 id="-menu-">左侧menu数据</h1>
<pre><code class="lang-js"> [
        {
          path: &#39;/user&#39;,
          name: &#39;user&#39;,
          label: &#39;用户管理&#39;,
          icon: &#39;user&#39;,
          url: &#39;UserManage/UserManage&#39;
        },
        {
          label: &#39;其他&#39;,
          icon: &#39;location&#39;,
          children: [
            {
              path: &#39;/page1&#39;,
              name: &#39;page1&#39;,
              label: &#39;页面1&#39;,
              icon: &#39;setting&#39;,
              url: &#39;Other/PageOne&#39;
            },
            {
              path: &#39;/page2&#39;,
              name: &#39;page2&#39;,
              label: &#39;页面2&#39;,
              icon: &#39;setting&#39;,
              url: &#39;Other/PageTwo&#39;
            }
          ]
        }
      ]
</code></pre>
<h1 id="-reset-less">基础reset.less</h1>
<pre><code class="lang-less">html,
body,
div,
span,
applet,
object,
iframe,
h1,
h2,
h3,
h4,
h5,
h6,
p,
blockquote,
pre,
a,
abbr,
acronym,
address,
big,
cite,
code,
del,
dfn,
em,
img,
ins,
kbd,
q,
s,
samp,
small,
strike,
strong,
sub,
sup,
tt,
var,
b,
u,
i,
center,
dl,
dt,
dd,
ol,
ul,
li,
fieldset,
form,
label,
legend,
table,
caption,
tbody,
tfoot,
thead,
tr,
th,
td,
article,
aside,
canvas,
details,
embed,
figure,
figcaption,
footer,
header,
hgroup,
menu,
nav,
output,
ruby,
section,
summary,
time,
mark,
audio,
video {
  margin: 0;
  padding: 0;
  border: 0;
  font-size: 100%;
  font: inherit;
  vertical-align: baseline;
  box-sizing: border-box;
}

/* HTML5 display-role reset for older browsers */
article,
aside,
details,
figcaption,
figure,
footer,
header,
hgroup,
menu,
nav,
section {
  display: block;
}

body {
  line-height: 1;
}

ol,
ul {
  list-style: none;
}

blockquote,
q {
  quotes: none;
}

blockquote:before,
blockquote:after,
q:before,
q:after {
  content: &#39;&#39;;
  content: none;
}

a,
a:hover {
  color: inherit;
  text-decoration: none;
}

table {
  border-collapse: collapse;
  border-spacing: 0;
}

html,
body {
  width: 100%;
  height: 100%;
  background-color: #f5f5f5;
  font-family: &#39;PingFangSC-Light&#39;, &#39;PingFang SC&#39;, &#39;STHeitiSC-Light&#39;, &#39;Helvetica-Light&#39;, &#39;Arial&#39;, &#39;sans-serif&#39;;
}

// 公共样式
.fl {
  float: left;
}

.fr {
  float: right;

  .button-group-item {
    padding-left: 3px;
  }
}

//清除浮动
.clearfix {
  zoom: 1;

  &amp;:after {
    display: block;
    clear: both;
    content: &quot;&quot;;
    visibility: hidden;
    height: 0;
  }
}

</code></pre>
<h1 id="home-tabledata">home页tableData</h1>
<pre><code class="lang-js">tableData: [
          {
            name: &#39;oppo&#39;,
            todayBuy: 500,
            monthBuy: 3500,
            totalBuy: 22000
          },
          {
            name: &#39;vivo&#39;,
            todayBuy: 300,
            monthBuy: 2200,
            totalBuy: 24000
          },
          {
            name: &#39;苹果&#39;,
            todayBuy: 800,
            monthBuy: 4500,
            totalBuy: 65000
          },
          {
            name: &#39;小米&#39;,
            todayBuy: 1200,
            monthBuy: 6500,
            totalBuy: 45000
          },
          {
            name: &#39;三星&#39;,
            todayBuy: 300,
            monthBuy: 2000,
            totalBuy: 34000
          },
          {
            name: &#39;魅族&#39;,
            todayBuy: 350,
            monthBuy: 3000,
            totalBuy: 22000
          }
        ]

</code></pre>
<h1 id="mock-">mock的使用</h1>
<ul>
<li>mock的作用</li>
<li>本地mock的使用</li>
<li>线上fastmock的使用</li>
</ul>
<h1 id="countdata">countData</h1>
<pre><code class="lang-js"> [
                {
                name: &quot;今日支付订单&quot;,
                value: 1234,
                icon: &quot;success&quot;,
                color: &quot;#2ec7c9&quot;,
                },
                {
                name: &quot;今日收藏订单&quot;,
                value: 210,
                icon: &quot;star-on&quot;,
                color: &quot;#ffb980&quot;,
                },
                {
                name: &quot;今日未支付订单&quot;,
                value: 1234,
                icon: &quot;s-goods&quot;,
                color: &quot;#5ab1ef&quot;,
                },
                {
                name: &quot;本月支付订单&quot;,
                value: 1234,
                icon: &quot;success&quot;,
                color: &quot;#2ec7c9&quot;,
                },
                {
                name: &quot;本月收藏订单&quot;,
                value: 210,
                icon: &quot;star-on&quot;,
                color: &quot;#ffb980&quot;,
                },
                {
                name: &quot;本月未支付订单&quot;,
                value: 1234,
                icon: &quot;s-goods&quot;,
                color: &quot;#5ab1ef&quot;,
                },
            ]

</code></pre>
<h1 id="echarts-">echarts表格数据</h1>
<pre><code class="lang-js">{
    &#39;orderData&#39;: {
      &quot;date&quot;: [&#39;20191001&#39;, &#39;20191002&#39;, &#39;20191003&#39;, &#39;20191004&#39;, &#39;20191005&#39;, &#39;20191006&#39;, &#39;20191007&#39;],
      &quot;data|7&quot;: [{
        &quot;苹果&quot;: &quot;@integer(1000, 5000)&quot;,
        &quot;小米&quot;: &quot;@integer(1000, 5000)&quot;,
        &quot;华为&quot;: &quot;@integer(1000, 5000)&quot;,
        &quot;oppo&quot;: &quot;@integer(1000, 5000)&quot;,
        &quot;vivo&quot;: &quot;@integer(1000, 5000)&quot;,
        &quot;一加&quot;: &quot;@integer(1000, 5000)&quot;,
      }]
    },
    &#39;videoData&#39;: [{
        name: &#39;小米&#39;,
        value: 2999
      },
      {
        name: &#39;苹果&#39;,
        value: 5999
      },
      {
        name: &#39;vivo&#39;,
        value: 1500
      },
      {
        name: &#39;oppo&#39;,
        value: 1999
      },
      {
        name: &#39;魅族&#39;,
        value: 2200
      },
      {
        name: &#39;三星&#39;,
        value: 4500
      }
    ],
    &#39;userData&#39;: [{
        date: &#39;周一&#39;,
        new: 5,
        active: 200
      },
      {
        date: &#39;周二&#39;,
        new: 10,
        active: 500
      },
      {
        date: &#39;周三&#39;,
        new: 12,
        active: 550
      },
      {
        date: &#39;周四&#39;,
        new: 60,
        active: 800
      },
      {
        date: &#39;周五&#39;,
        new: 65,
        active: 550
      },
</code></pre>
<h1 id="-echarts-">折线图和柱状图的echarts配置</h1>
<pre><code class="lang-js">{
      // 图例文字颜色
      textStyle: {
        color: &quot;#333&quot;,
      },
      grid: {
        left: &quot;20%&quot;,
      },
      // 提示框
      tooltip: {
        trigger: &quot;axis&quot;,
      },
      xAxis: {
        type: &quot;category&quot;, // 类目轴
        data: [],
        axisLine: {
          lineStyle: {
            color: &quot;#17b3a3&quot;,
          },
        },
        axisLabel: {
          interval: 0,
          color: &quot;#333&quot;,
        },
      },
      yAxis: [
        {
          type: &quot;value&quot;,
          axisLine: {
            lineStyle: {
              color: &quot;#17b3a3&quot;,
            },
          },
        },
      ],
      color: [&quot;#2ec7c9&quot;, &quot;#b6a2de&quot;, &quot;#5ab1ef&quot;, &quot;#ffb980&quot;, &quot;#d87a80&quot;, &quot;#8d98b3&quot;],
      series: [],
    }
</code></pre>
<pre><code class="lang-js">// 饼状图的配置
{
      tooltip: {
        trigger: &quot;item&quot;,
      },
      color: [
        &quot;#0f78f4&quot;,
        &quot;#dd536b&quot;,
        &quot;#9462e5&quot;,
        &quot;#a6a6a6&quot;,
        &quot;#e1bb22&quot;,
        &quot;#39c362&quot;,
        &quot;#3ed1cf&quot;,
      ],
      series: [],
    }

</code></pre>
<h1 id="tag-">tag 实战步骤</h1>
<ol>
<li>首页的tag一开始就会存在，而且是不能进行删除的</li>
<li>当点击左侧栏的时候,如果tag没有该菜单名称则新增，如果已经有了那么当前tag背景为蓝色。</li>
<li>删除当前tag，如果是最后一个，那么路由调整到它前面那个标签并且背景变蓝，如果不是最后一个那么路由调整到它后面那个标签并且背景变蓝。</li>
<li>还有我们注意这个tag不论路由如何切换都是会存在的，所以这个tag一定要存在我们之前定义的Main.vue中。
<img src="./%E9%9D%A2%E5%8C%85%E5%B1%91.jpg" alt="面包屑的说明"></li>
</ol>
<h1 id="user-">user展示</h1>
<ul>
<li>表头配置<pre><code class="lang-js">const tableLabel = reactive([
    {
      prop: &quot;name&quot;,
      label: &quot;姓名&quot;,
    },
    {
      prop: &quot;age&quot;,
      label: &quot;年龄&quot;,
    },
    {
      prop: &quot;sexLabel&quot;,
      label: &quot;性别&quot;,
    },
    {
      prop: &quot;birth&quot;,
      label: &quot;出生日期&quot;,
      width: 200,
    },
    {
      prop: &quot;addr&quot;,
      label: &quot;地址&quot;,
      width: 320,
    },
  ]);
</code></pre>
</li>
<li>userMock模拟函数
<code>`</code>js
import Mock from &#39;mockjs&#39;</li>
</ul>
<p>// get请求从config.url获取参数，post从config.body中获取参数
function param2Obj(url) {
  const search = url.split(&#39;?&#39;)[1]
  if (!search) {
    return {}
  }
  return JSON.parse(
    &#39;{&quot;&#39; +
    decodeURIComponent(search)
      .replace(/&quot;/g, &#39;\&quot;&#39;)
      .replace(/&amp;/g, &#39;&quot;,&quot;&#39;)
      .replace(/=/g, &#39;&quot;:&quot;&#39;) +
    &#39;&quot;}&#39;
  )
}</p>
<p>let List = []
const count = 200</p>
<p>for (let i = 0; i &lt; count; i++) {
  List.push(
    Mock.mock({
      id: Mock.Random.guid(),
      name: Mock.Random.cname(),
      addr: Mock.mock(&#39;@county(true)&#39;),
      &#39;age|18-60&#39;: 1,
      birth: Mock.Random.date(),
      sex: Mock.Random.integer(0, 1)
    })
  )
}</p>
<p>export default {
  /**</p>
<ul>
<li>获取列表</li>
<li>要带参数 name, page, limt; name可以不填, page,limit有默认值。</li>
<li>@param name, page, limit</li>
<li>@return {{code: number, count: number, data: <em>[]}}
</em>/
getUserList: config =&gt; {
const { name, page = 1, limit = 20 } = param2Obj(config.url)
const mockList = List.filter(user =&gt; {
 if (name &amp;&amp; user.name.indexOf(name) === -1 &amp;&amp; user.addr.indexOf(name) === -1) return false
 return true
})
const pageList = mockList.filter((item, index) =&gt; index &lt; limit <em> page &amp;&amp; index &gt;= limit </em> (page - 1))
return {
 code: 200,
 data: {
   list: pageList,
   count: mockList.length,
 }
}
},
/**</li>
<li>增加用户</li>
<li>@param name, addr, age, birth, sex</li>
<li>@return {{code: number, data: {message: string}}}
*/
createUser: config =&gt; {
const { name, addr, age, birth, sex } = JSON.parse(config.body)
console.log(JSON.parse(config.body))
List.unshift({
 id: Mock.Random.guid(),
 name: name,
 addr: addr,
 age: age,
 birth: birth,
 sex: sex
})
return {
 code: 20000,
 data: {
   message: &#39;添加成功&#39;
 }
}
},
/**</li>
<li>删除用户</li>
<li>@param id</li>
<li>@return {<em>}
</em>/
deleteUser: config =&gt; {
const { id } = param2Obj(config.url)
if (!id) {
 return {
   code: -999,
   message: &#39;参数不正确&#39;
 }
} else {
 List = List.filter(u =&gt; u.id !== id)
 return {
   code: 20000,
   message: &#39;删除成功&#39;
 }
}
},
/**</li>
<li>批量删除</li>
<li>@param config</li>
<li>@return {{code: number, data: {message: string}}}
*/
batchremove: config =&gt; {
let { ids } = param2Obj(config.url)
ids = ids.split(&#39;,&#39;)
List = List.filter(u =&gt; !ids.includes(u.id))
return {
 code: 20000,
 data: {
   message: &#39;批量删除成功&#39;
 }
}
},
/**</li>
<li>修改用户</li>
<li>@param id, name, addr, age, birth, sex</li>
<li>@return {{code: number, data: {message: string}}}
*/
updateUser: config =&gt; {
const { id, name, addr, age, birth, sex } = JSON.parse(config.body)
const sex_num = parseInt(sex)
List.some(u =&gt; {
 if (u.id === id) {
   u.name = name
   u.addr = addr
   u.age = age
   u.birth = birth
   u.sex = sex_num
   return true
 }
})
return {
 code: 20000,
 data: {
   message: &#39;编辑成功&#39;
 }
}
}
}
<code>`</code></li>
</ul>
<h1 id="-">权限管理</h1>
<p>根据用户登录的角色不同，返回的左侧的操作菜单也不一样</p>
<ol>
<li><p>登录页面</p>
</li>
<li><p>登录了以后 返回左侧的菜单列表</p>
<pre><code class="lang-js">import Mock from &#39;mockjs&#39;
export default {
getMenu: config =&gt; {
 const { username, password } = JSON.parse(config.body)
 // 先判断用户是否存在
 // 判断账号和密码是否对应
 if (username === &#39;admin&#39; &amp;&amp; password === &#39;admin&#39;) {
   return {
     code: 20000,
     data: {
       menu: [
         {
           path: &#39;/home&#39;,
           name: &#39;home&#39;,
           label: &#39;首页&#39;,
           icon: &#39;s-home&#39;,
           url: &#39;home/index&#39;
         },
         {
           path: &#39;/mall&#39;,
           name: &#39;mall&#39;,
           label: &#39;商品管理&#39;,
           icon: &#39;video-play&#39;,
           url: &#39;mall/index&#39;
         },
         {
           path: &#39;/user&#39;,
           name: &#39;user&#39;,
           label: &#39;用户管理&#39;,
           icon: &#39;user&#39;,
           url: &#39;User/index&#39;
         },
         {
           label: &#39;其他&#39;,
           icon: &#39;location&#39;,
           children: [
             {
               path: &#39;/page1&#39;,
               name: &#39;page1&#39;,
               label: &#39;页面1&#39;,
               icon: &#39;setting&#39;,
               url: &#39;other/pageOne.vue&#39;
             },
             {
               path: &#39;/page2&#39;,
               name: &#39;page2&#39;,
               label: &#39;页面2&#39;,
               icon: &#39;setting&#39;,
               url: &#39;other/pageTwo.vue&#39;
             }
           ]
         }
       ],
       token: Mock.Random.guid(),
       message: &#39;获取成功&#39;
     }
   }
 } else if (username === &#39;xiaoxiao&#39; &amp;&amp; password === &#39;xiaoxiao&#39;) {
   return {
     code: 20000,
     data: {
       menu: [
         {
           path: &#39;/&#39;,
           name: &#39;home&#39;,
           label: &#39;首页&#39;,
           icon: &#39;s-home&#39;,
           url: &#39;home/index&#39;
         },
         {
           path: &#39;/video&#39;,
           name: &#39;video&#39;,
           label: &#39;商品管理&#39;,
           icon: &#39;video-play&#39;,
           url: &#39;mall/index&#39;
         }
       ],
       token: Mock.Random.guid(),
       message: &#39;获取成功&#39;
     }
   }
 } else {
   return {
     code: -999,
     data: {
       message: &#39;密码错误&#39;
     }
   }
 }

}
}
</code></pre>
</li>
<li><p>存储到vuex当中去,aside组件显示出来</p>
</li>
<li><p>解决持久化的数据问题</p>
</li>
</ol>

          	</article>
        </div>
		</div>
  </body>
</html>
<script type="text/javascript" src="toc/js/jquery-1.4.4.min.js"></script>
<script type="text/javascript" src="toc/js/jquery.ztree.all-3.5.min.js"></script>
<script type="text/javascript" src="toc/js/ztree_toc.js"></script>
<script type="text/javascript" src="toc_conf.js"></script>

<SCRIPT type="text/javascript" >
<!--
$(document).ready(function(){
    var css_conf = eval(markdown_panel_style);
    $('#readme').css(css_conf)
    
    var conf = eval(jquery_ztree_toc_opts);
		$('#tree').ztree_toc(conf);
});
//-->
</SCRIPT>